class com.techsmith.camtasia.flash.player.managers.QuizManager
{
   var m_bAlreadyReportedScores;
   var m_fFPS;
   var m_objGlobalQuizData;
   var m_arrQuizData;
   var m_arrAllPopups;
   var m_objQuizData;
   var m_bUseCookie = true;
   function QuizManager()
   {
      this.m_bAlreadyReportedScores = false;
      this.m_fFPS = 1;
   }
   function init(arrQuizData, objGlobalQuizData, bUseCookie)
   {
      this.m_bUseCookie = bUseCookie;
      this.m_objGlobalQuizData = objGlobalQuizData;
      this.m_arrQuizData = arrQuizData;
      this.m_arrAllPopups = new Array();
      var _loc3_ = 0;
      while(_loc3_ < this.m_arrQuizData.length)
      {
         var _loc2_ = 0;
         while(_loc2_ < this.m_arrQuizData[_loc3_].popup.length)
         {
            this.m_arrAllPopups.push(this.m_arrQuizData[_loc3_].popup[_loc2_]);
            _loc2_ = _loc2_ + 1;
         }
         _loc3_ = _loc3_ + 1;
      }
   }
   function initIndex(idx, fFPS, fLastFrameTime)
   {
      this.m_fFPS = fFPS;
      this.m_objQuizData = this.m_arrQuizData[idx];
      this.onDoneLoadingXML(fLastFrameTime);
   }
   function onDoneLoadingXML(fLastFrameTime)
   {
      for(var _loc4_ in this.m_objQuizData.popup)
      {
         var _loc2_ = this.m_objQuizData.popup[_loc4_];
         _loc2_.time = Math.min(_loc2_.time,fLastFrameTime);
         _loc2_.frame = Math.max(1,Math.round(Number(_loc2_.time) * this.m_fFPS));
         _loc2_.nextID = this.m_objQuizData["frm" + _loc2_.frame];
         _loc2_.data.feedback = _loc2_.data.feedback && !this.m_objGlobalQuizData.disableFeedback;
         this.m_objQuizData["pop" + this.m_objQuizData["frm" + _loc2_.frame]].prevID = _loc2_.ID;
         this.m_objQuizData["frm" + _loc2_.frame] = _loc2_.ID;
         this.m_objQuizData["pop" + _loc2_.ID] = _loc2_;
      }
      if(this.m_bUseCookie)
      {
         this.loadAllUserInput();
      }
   }
   function popup(nPopupID)
   {
      return this.m_objQuizData["pop" + nPopupID];
   }
   function popupIDOnFrame(nFrame)
   {
      return this.m_objQuizData["frm" + nFrame];
   }
   function popupIDOnFrameRange(nFrame0, nFrame1)
   {
      var _loc2_ = nFrame0;
      while(_loc2_ <= nFrame1)
      {
         if(this.popupIDOnFrame(_loc2_) != undefined)
         {
            return this.popupIDOnFrame(_loc2_);
         }
         _loc2_ = _loc2_ + 1;
      }
      return undefined;
   }
   function popupNextID(nPopupID)
   {
      return this.popup(nPopupID).nextID;
   }
   function popupPrevID(nPopupID)
   {
      return this.popup(nPopupID).prevID;
   }
   function popupNextIDInGroup(nPopupID)
   {
      var _loc2_ = this.popup(nPopupID).nextID;
      return !(_loc2_ != undefined && this.popup(nPopupID).data.title == this.popup(_loc2_).data.title) ? undefined : _loc2_;
   }
   function popupPrevIDInGroup(nPopupID)
   {
      var _loc2_ = this.popup(nPopupID).prevID;
      return !(_loc2_ != undefined && this.popup(nPopupID).data.title == this.popup(_loc2_).data.title) ? undefined : _loc2_;
   }
   function groupStats(nPopupID)
   {
      var _loc4_ = 0;
      var _loc5_ = 0;
      var _loc2_ = nPopupID;
      while(_loc2_ != undefined)
      {
         _loc4_ = _loc4_ + 1;
         _loc2_ = this.popupPrevIDInGroup(_loc2_);
      }
      _loc2_ = nPopupID;
      while(_loc2_ != undefined)
      {
         _loc5_ = _loc5_ + 1;
         _loc2_ = this.popupNextIDInGroup(_loc2_);
      }
      return {pos:_loc4_,tot:_loc5_ + _loc4_ - 1};
   }
   function popupNextIDRange(nPopupID, nFrame1)
   {
      var _loc2_ = this.popup(nPopupID);
      return _loc2_.nextID == undefined ? this.popupIDOnFrameRange(_loc2_.frame + 1,nFrame1) : _loc2_.nextID;
   }
   function getPopupData(nPopupID)
   {
      if(this.popup(nPopupID).type == "summary")
      {
         var _loc2_ = new Object();
         _loc2_.nNumQ = this.countQuestions();
         _loc2_.nNumQScored = this.countQuestions(this.isScored);
         _loc2_.nNumQCorrect = this.countQuestions(this.isScored,this.isCorrect);
         _loc2_.nNumQAnswered = this.countQuestions(this.isAnswered);
         _loc2_.nNumQScoredUnanswered = this.countQuestions(this.isScored,this.isUnanswered);
         _loc2_.nNumQUnscoredUnanswered = this.countQuestions(this.isUnscored,this.isUnanswered);
         _loc2_.bAlreadyReportedScores = this.m_bAlreadyReportedScores;
         _loc2_.strEmailContent = this.getEmailContent();
         this.popup(nPopupID).data.dyn = _loc2_;
      }
      return this.popup(nPopupID).data;
   }
   function getPopupFilename(nPopupID)
   {
      return this.popup(nPopupID).filename;
   }
   function reportResults(nPopupID, objUserData)
   {
      this.popup(nPopupID).data.userData = objUserData;
      if(this.m_bUseCookie)
      {
         this.saveUserInput(nPopupID);
      }
      return !(!objUserData.bCorrect && int(this.popup(nPopupID).data.feedback)) ? {} : this.popup(nPopupID).data;
   }
   function isQuestionID(nPopupID)
   {
      return this.isQuestion(this.popup(nPopupID));
   }
   function isQuestion(objPopup)
   {
      return objPopup.type == "question";
   }
   function isCorrect(objPopup)
   {
      return objPopup.data.userData.bCorrect;
   }
   function isAnswered(objPopup)
   {
      return objPopup.data.userData.strAnswer != undefined && objPopup.data.userData.strAnswer != "";
   }
   function isUnanswered(objPopup)
   {
      return !this.isAnswered(objPopup);
   }
   function isScored(objPopup)
   {
      return objPopup.data.scored;
   }
   function isUnscored(objPopup)
   {
      return !objPopup.data.scored;
   }
   function isTrue()
   {
      return true;
   }
   function countQuestions(func1, func2)
   {
      func1 = func1 == undefined ? this.isTrue : func1;
      func2 = func2 == undefined ? this.isTrue : func2;
      var _loc6_ = 0;
      var _loc3_ = 0;
      while(_loc3_ < this.m_arrAllPopups.length)
      {
         var _loc2_ = this.m_arrAllPopups[_loc3_];
         _loc6_ += !(this.isQuestion(_loc2_) && func1(_loc2_) && func2(_loc2_)) ? 0 : 1;
         _loc3_ = _loc3_ + 1;
      }
      return _loc6_;
   }
   function numQScored()
   {
      return this.countQuestions(this.isScored);
   }
   function numQCorrect()
   {
      return this.countQuestions(this.isScored,this.isCorrect);
   }
   function numQ()
   {
      return this.countQuestions();
   }
   function numQAnswered()
   {
      return this.countQuestions(this.isAnswered);
   }
   function getEmailContent()
   {
      var _loc4_ = "";
      var _loc7_ = 1;
      var _loc5_ = "";
      if(this.m_objGlobalQuizData.includeScoreInEmail)
      {
         _loc4_ += com.techsmith.utils.Util.sprintf(this.m_objGlobalQuizData.txtScore,this.numQCorrect(),this.numQScored()) + "\n\n";
      }
      var _loc3_ = 0;
      while(_loc3_ < this.m_arrAllPopups.length)
      {
         var _loc2_ = this.m_arrAllPopups[_loc3_];
         if(this.isQuestion(_loc2_))
         {
            if(_loc2_.data.title != _loc5_)
            {
               if(_loc5_ != "")
               {
                  _loc4_ += "\n";
               }
               _loc4_ += _loc2_.data.title + "\n";
               _loc7_ = 1;
            }
            var _loc6_ = _loc2_.data.userData.strAnswer == undefined ? "---" : _loc2_.data.userData.strAnswer;
            _loc7_;
            _loc4_ += _loc7_++ + ". " + _loc6_ + "\n";
            _loc5_ = _loc2_.data.title;
         }
         _loc3_ = _loc3_ + 1;
      }
      return _loc4_;
   }
   function getCookie()
   {
      return SharedObject.getLocal("quizdata");
   }
   function saveUserInput(nPopupID)
   {
      var _loc2_ = this.getCookie();
      _loc2_.data["popup" + nPopupID] = this.popup(nPopupID).data.userData;
      _loc2_.flush();
   }
   function loadAllUserInput()
   {
      var _loc4_ = this.getCookie();
      var _loc2_ = 0;
      while(_loc2_ < this.m_objQuizData.popup.length)
      {
         var _loc3_ = this.m_objQuizData.popup[_loc2_];
         _loc3_.data.userData = _loc4_.data["popup" + _loc3_.ID];
         _loc2_ = _loc2_ + 1;
      }
   }
   function clearCookie()
   {
      var _loc2_ = this.getCookie();
      for(var _loc3_ in _loc2_.data)
      {
         delete _loc2_.data[_loc3_];
      }
      _loc2_.flush();
   }
}
