class com.techsmith.camtasia.flash.player.quiz.feedback.TSQuizFeedback extends com.techsmith.widgets.Movable implements com.techsmith.utils.events.IEventDispatcher
{
   var destroyObject;
   var m_dispatcher = null;
   var m_feedbackField = null;
   var m_feedbackFormat = null;
   var m_subFeedbackField = null;
   var m_subFeedbackFormat = null;
   var m_background = null;
   var m_mask = null;
   var m_exitBtn = null;
   var m_scrollBar = null;
   var m_bgColor = 0;
   var m_bgAlpha = 90;
   var m_width = null;
   var m_height = 0;
   var m_isVisible = false;
   var m_fontColor = 16777215;
   var m_tween = null;
   var m_duration = null;
   static var EXIT_HEIGHT = 15;
   static var EXIT_WIDTH = 21.3;
   static var EXIT_HPADDING = 6;
   static var EXIT_VPADDING = 4;
   static var MESSAGE_HPADDING = com.techsmith.camtasia.flash.player.quiz.feedback.TSQuizFeedback.EXIT_HPADDING * 2 + com.techsmith.camtasia.flash.player.quiz.feedback.TSQuizFeedback.EXIT_WIDTH;
   static var FEEDBACK_MAXHEIGHT = 185;
   static var HEADING_HEIGHT = 38;
   function TSQuizFeedback()
   {
      super();
      this.m_dispatcher = new com.techsmith.utils.events.EventDispatcher();
      this.m_isVisible = false;
   }
   static function create(container, name, depth, init)
   {
      var _loc1_ = container.attachMovie("TSQuizFeedback",name,depth,init);
      return com.techsmith.camtasia.flash.player.quiz.feedback.TSQuizFeedback(_loc1_);
   }
   function init(width, tf, stf, speed)
   {
      this.m_width = width;
      if(speed != undefined && speed != null)
      {
         if(speed < 1)
         {
            speed = 1;
         }
         this.m_duration = speed / 100;
      }
      else
      {
         this.m_duration = 1;
      }
      this.createFormat(tf);
      this.createSubFormat(stf);
      this.m_background = this.createEmptyMovieClip("m_background",1);
      this.drawExitButton();
      this.drawMask();
      this.m_background.setMask(this.m_mask);
      this.m_exitBtn.addEventListener("click",this);
   }
   function draw(subField)
   {
      this.drawBackground();
      this.drawMessageField();
      if(subField)
      {
         this.drawSubField();
      }
      this.drawMask();
      this.m_background.setMask(this.m_mask);
      this.m_background._y = this.m_height;
   }
   function drawBackground()
   {
      this.m_background.clear();
      com.techsmith.utils.shapes.Rectangle.draw(this.m_background,this.m_bgColor,this.m_width,this.m_height,this.m_bgAlpha);
   }
   function createFormat(style)
   {
      this.m_feedbackFormat = new TextFormat();
      this.m_feedbackFormat.font = "Arial";
      this.m_feedbackFormat.size = 30;
      this.m_feedbackFormat.bold = true;
      this.m_feedbackFormat.align = "center";
      this.m_feedbackFormat.color = this.m_fontColor;
      if(style != undefined || style != null)
      {
         for(var _loc3_ in style)
         {
            this.m_feedbackFormat[_loc3_] = style[_loc3_];
         }
      }
   }
   function createSubFormat(style)
   {
      this.m_subFeedbackFormat = new TextFormat();
      this.m_subFeedbackFormat.font = "Arial";
      this.m_subFeedbackFormat.size = 14;
      this.m_subFeedbackFormat.bold = false;
      this.m_subFeedbackFormat.align = "center";
      this.m_subFeedbackFormat.leftMargin = 10;
      this.m_subFeedbackFormat.rightMargin = 10;
      this.m_subFeedbackFormat.color = this.m_fontColor;
      if(style != undefined || style != null)
      {
         for(var _loc3_ in style)
         {
            this.m_subFeedbackFormat[_loc3_] = style[_loc3_];
         }
      }
   }
   function drawMessageField()
   {
      this.m_background.createTextField("m_feedbackField",4,com.techsmith.camtasia.flash.player.quiz.feedback.TSQuizFeedback.MESSAGE_HPADDING,0,this.m_width - com.techsmith.camtasia.flash.player.quiz.feedback.TSQuizFeedback.MESSAGE_HPADDING * 2,com.techsmith.camtasia.flash.player.quiz.feedback.TSQuizFeedback.HEADING_HEIGHT);
      this.m_feedbackField = this.m_background.m_feedbackField;
   }
   function drawSubField()
   {
      this.m_background.createTextField("m_subField",5,0,com.techsmith.camtasia.flash.player.quiz.feedback.TSQuizFeedback.HEADING_HEIGHT,this.m_width,this.m_height - com.techsmith.camtasia.flash.player.quiz.feedback.TSQuizFeedback.HEADING_HEIGHT);
      this.m_subFeedbackField = this.m_background.m_subField;
      this.m_subFeedbackField.multiline = true;
      this.m_subFeedbackField.wordWrap = true;
   }
   function drawExitButton()
   {
      this.m_exitBtn = com.techsmith.widgets.button.TSSimpleButton.create(this.m_background,"m_exitBtn",6);
      this.m_exitBtn.init(new com.techsmith.widgets.button.TSButtonStyle("Exit",null,false));
      this.m_exitBtn.move(this.m_width - (this.m_exitBtn._width + com.techsmith.camtasia.flash.player.quiz.feedback.TSQuizFeedback.EXIT_HPADDING),com.techsmith.camtasia.flash.player.quiz.feedback.TSQuizFeedback.EXIT_VPADDING);
   }
   function drawMask()
   {
      this.m_mask = this.createEmptyMovieClip("m_mask",2);
      com.techsmith.utils.shapes.Rectangle.draw(this.m_mask,this.m_bgColor,this.m_width,this.m_height,this.m_bgAlpha);
      this.m_mask._x = 0;
      this.m_mask._y = 0;
   }
   function closeAnimation()
   {
      this.m_tween = new mx.transitions.Tween(this.m_background,"_y",mx.transitions.easing.Regular.easeOut,this.m_height,0,this.m_duration,true);
      this.m_tween.onMotionFinished = com.techsmith.utils.Delegate.create(this,this.onMotionFinished);
      this.destroyObject("m_scrollBar");
   }
   function openAnimation()
   {
      this.m_tween = new mx.transitions.Tween(this.m_background,"_y",mx.transitions.easing.Regular.easeOut,0,this.m_height,this.m_duration,true);
      this.m_tween.onMotionFinished = com.techsmith.utils.Delegate.create(this,this.onMotionFinished);
   }
   function animate(open)
   {
      if(open != this.m_isVisible)
      {
         if(open)
         {
            this.closeAnimation();
         }
         else
         {
            this.openAnimation();
         }
      }
      this.m_isVisible = open;
   }
   function onMotionFinished()
   {
      delete this.m_tween.onMotionFinished;
      if(this.m_isVisible)
      {
         if(this.m_subFeedbackField.maxscroll > 1)
         {
            this.m_subFeedbackField._width -= 16;
            this.m_scrollBar = this.m_background.createClassObject(mx.controls.UIScrollBar,"m_scrollBar",28);
            this.m_scrollBar.setSize(16,this.m_subFeedbackField._height);
            this.m_scrollBar.move(this.m_width - 16,this.m_subFeedbackField._y);
            this.m_scrollBar.setScrollTarget(this.m_subFeedbackField);
         }
      }
   }
   function setFeedback(qlevel, alevel)
   {
      this.m_height = com.techsmith.camtasia.flash.player.quiz.feedback.TSQuizFeedback.HEADING_HEIGHT;
      var _loc3_ = false;
      if(alevel != undefined && alevel != null && alevel != "")
      {
         _loc3_ = true;
         var _loc4_ = this.m_subFeedbackFormat.getTextExtent(alevel,this.m_width);
         this.m_height = _loc4_.textFieldHeight + com.techsmith.camtasia.flash.player.quiz.feedback.TSQuizFeedback.HEADING_HEIGHT;
         if(this.m_height > com.techsmith.camtasia.flash.player.quiz.feedback.TSQuizFeedback.FEEDBACK_MAXHEIGHT)
         {
            this.m_height = com.techsmith.camtasia.flash.player.quiz.feedback.TSQuizFeedback.FEEDBACK_MAXHEIGHT;
         }
      }
      this.draw(_loc3_);
      this.m_feedbackField.text = qlevel;
      this.m_feedbackField.setTextFormat(this.m_feedbackFormat);
      if(_loc3_)
      {
         this.m_subFeedbackField.text = alevel;
         this.m_subFeedbackField.setTextFormat(this.m_subFeedbackFormat);
      }
   }
   function getHeight()
   {
      return this.m_height;
   }
   function getWidth()
   {
      return this.m_width;
   }
   function getLocation()
   {
      var _loc3_ = this._x;
      var _loc2_ = this._y;
      return {x:_loc3_,y:_loc2_};
   }
   function click(evt)
   {
      this.destroyObject("m_scrollBar");
      this.animate(false);
      this.sendEvent({target:this,type:"close"});
   }
   function sendEvent(e)
   {
      this.dispatchEvent(e);
   }
   function addEventListener(event, scope)
   {
      this.m_dispatcher.addEventListener(event,scope);
   }
   function removeEventListener(event, scope)
   {
      this.m_dispatcher.removeEventListener(event,scope);
   }
   function dispatchEvent(eventObj)
   {
      this.m_dispatcher.dispatchEvent(eventObj);
   }
   function removeAllListeners()
   {
      this.m_dispatcher.removeAllListeners();
   }
}
