class com.techsmith.camtasia.flash.player.quiz.questions.QuestionBase extends com.techsmith.widgets.Movable
{
   var m_parent;
   static var QUESTION_PADDING = 10;
   static var QUESTION_TEXT_WIDTH = 437;
   var m_width = null;
   var m_height = null;
   var m_questionData = null;
   var m_question = null;
   var m_questionField = null;
   var m_questionFormat = null;
   var m_questionHeight = null;
   var m_background = null;
   function QuestionBase()
   {
      super();
   }
   function init(w, h, parent, objQuestionData)
   {
      this.m_width = w;
      this.m_height = h;
      this.m_parent = parent;
      this.m_questionData = objQuestionData;
      this.m_question = this.m_questionData.question;
      this.createQuestionField();
   }
   function drawBackground()
   {
   }
   function createQuestionField()
   {
      this.m_questionFormat = new TextFormat();
      this.m_questionFormat.align = "left";
      this.m_questionFormat.font = "Arial";
      this.m_questionFormat.bold = false;
      this.m_questionFormat.size = 14;
      this.m_questionFormat.color = 6710886;
      var _loc2_ = this.m_questionFormat.getTextExtent(this.m_question,com.techsmith.camtasia.flash.player.quiz.questions.QuestionBase.QUESTION_TEXT_WIDTH);
      this.m_questionHeight = _loc2_.textFieldHeight;
      this.createTextField("m_questionField",7,13,10,com.techsmith.camtasia.flash.player.quiz.questions.QuestionBase.QUESTION_TEXT_WIDTH,this.m_questionHeight);
      this.m_questionField.multiline = true;
      this.m_questionField.wordWrap = true;
      this.m_questionField.html = false;
   }
   function changedAnswer()
   {
      this.m_parent.changedAnswer();
   }
   function notImpl()
   {
      var _loc1_ = 0;
      while(_loc1_ < 10000)
      {
         trace("NOT IMPL");
         _loc1_ = _loc1_ + 1;
      }
   }
   function setQuestion(q)
   {
      this.m_question = q;
      if(this.m_questionField.html)
      {
         this.m_questionField.htmlText = q;
      }
      else
      {
         this.m_questionField.text = q;
      }
      this.m_questionField.setTextFormat(this.m_questionFormat);
   }
   function getAnswer()
   {
      this.notImpl();
      return "";
   }
   function isCorrect()
   {
      this.notImpl();
      return false;
   }
   function isReadyToSubmit()
   {
      return this.getAnswer() != "";
   }
   function isSurvey()
   {
      return this.m_questionData.survey;
   }
   function hasFeedback()
   {
      return Boolean(this.m_questionData.feedback);
   }
   function getUserData()
   {
      return {strAnswer:this.getAnswer(),bCorrect:this.isCorrect()};
   }
   function getFeedback()
   {
      if(!this.hasFeedback())
      {
         return {strFeedback:"",strDetailedFeedback:""};
      }
      return {strFeedback:(!this.isCorrect() ? this.m_questionData.incorrect : this.m_questionData.correct),strDetailedFeedback:""};
   }
   function getSubmitButtonText()
   {
      return this.m_questionData.submit;
   }
   function adjustForScrollBar(bScrollBars)
   {
      var _loc2_ = !bScrollBars ? com.techsmith.camtasia.flash.player.quiz.questions.QuestionBase.QUESTION_TEXT_WIDTH : com.techsmith.camtasia.flash.player.quiz.questions.QuestionBase.QUESTION_TEXT_WIDTH - 16;
      if(this.m_questionField._width == _loc2_)
      {
         return undefined;
      }
      this.m_questionField._width = _loc2_;
      var _loc3_ = this.m_questionFormat.getTextExtent(this.m_question,this.m_questionField._width);
      this.m_questionField._height = this.m_questionHeight = _loc3_.textFieldHeight;
   }
}
