class com.techsmith.camtasia.flash.player.quiz.ui.frames.TSQuizFrame extends com.techsmith.camtasia.flash.player.quiz.ui.frames.TSQuizFrameBase implements com.techsmith.camtasia.flash.player.quiz.IQuestionToFrameMsg, com.techsmith.camtasia.flash.player.quiz.IQuestionViewFrame
{
   var m_parent;
   var m_currentQuestion;
   var m_curQuestionOrigUserData;
   var m_prevBtn = null;
   var m_submitBtn = null;
   var m_nextBtn = null;
   var m_feedbackPanel = null;
   function TSQuizFrame()
   {
      super();
   }
   static function create(container, name, depth, init)
   {
      var _loc1_ = container.attachMovie("TSQuizFrame",name,depth,init);
      return com.techsmith.camtasia.flash.player.quiz.ui.frames.TSQuizFrame(_loc1_);
   }
   function init(w, h, parent)
   {
      super.init(w,h);
      this.m_parent = parent;
      this.m_prevBtn = com.techsmith.camtasia.flash.player.quiz.ui.buttons.TSQuizPrevButton.create(this,"m_prevBtn",3);
      this.m_prevBtn.init(this.m_parent.getTextObj().txtPrev);
      this.m_prevBtn.move(312,312.6);
      this.m_prevBtn.addEventListener("click",com.techsmith.utils.Delegate.create(this,this.onPrevQuestion));
      this.m_submitBtn = com.techsmith.camtasia.flash.player.quiz.ui.buttons.TSQuizSubmitButton.create(this,"m_submitBtn",4);
      this.m_submitBtn.init(this.m_parent.getTextObj().txtSubmit);
      this.m_submitBtn.move(360,312.6);
      this.m_submitBtn.addEventListener("click",com.techsmith.utils.Delegate.create(this,this.onSubmit));
      this.m_nextBtn = com.techsmith.camtasia.flash.player.quiz.ui.buttons.TSQuizNextButton.create(this,"m_nextBtn",5);
      this.m_nextBtn.init("");
      this.m_nextBtn.move(408,312.6);
      this.m_nextBtn.addEventListener("click",com.techsmith.utils.Delegate.create(this,this.onNextQuestion));
      this.m_feedbackPanel = com.techsmith.camtasia.flash.player.quiz.feedback.TSQuizFeedback.create(this,"m_feedbackPanel",15);
      this.m_feedbackPanel.init(450,null,null,25);
      this.m_feedbackPanel.addEventListener("close",com.techsmith.utils.Delegate.create(this,this.feedbackCloseHandler));
   }
   function initQuestion(qType, qdata)
   {
      this.m_currentQuestion.dispose();
      switch(qType.substr(0,4))
      {
         case "fitb":
            this.m_currentQuestion = com.techsmith.camtasia.flash.player.quiz.questions.TSFIB.create(this.m_content,"m_currentQuestion",6);
            break;
         case "mult":
            this.m_currentQuestion = com.techsmith.camtasia.flash.player.quiz.questions.TSMultipleChoice.create(this.m_content,"m_currentQuestion",6);
            break;
         case "shor":
            this.m_currentQuestion = com.techsmith.camtasia.flash.player.quiz.questions.TSShortAnswer.create(this.m_content,"m_currentQuestion",6);
            break;
         case "tf":
            this.m_currentQuestion = com.techsmith.camtasia.flash.player.quiz.questions.TSTrueFalse.create(this.m_content,"m_currentQuestion",6);
            break;
         case "likert":
            this.m_currentQuestion = com.techsmith.camtasia.flash.player.quiz.questions.TSLikert.create(this.m_content,"m_currentQuestion",6);
            break;
         default:
            this.m_currentQuestion = com.techsmith.camtasia.flash.player.quiz.questions.TSMultipleChoice.create(this.m_content,"m_currentQuestion",6);
      }
      this.m_currentQuestion.init(this.m_width - 20,this.m_height - 70,this,qdata);
      this.m_currentQuestion.move(0,0);
      this.m_nextBtn.setLabel(!this.m_parent.isNextQuestion() ? this.m_parent.getTextObj().txtDone : this.m_parent.getTextObj().txtNext);
      this.m_scrollPane.size();
      this.m_scrollPane.vPosition = 0;
      var _loc2_ = this.m_parent.groupStats();
      this.setStatus(com.techsmith.utils.Util.sprintf(this.m_parent.getTextObj().txtQuestionOf,_loc2_.pos,_loc2_.tot));
      this.m_curQuestionOrigUserData = this.m_currentQuestion.getUserData();
      this.updatePrevNextSubmit();
   }
   function changedAnswer()
   {
      this.updatePrevNextSubmit();
      this.m_feedbackPanel.animate(false);
   }
   function updatePrevNextSubmit()
   {
      var _loc2_ = this.userHasChangedAnswer();
      this.m_submitBtn.setEnabled(this.m_currentQuestion.isReadyToSubmit() && _loc2_ && this.m_currentQuestion.hasFeedback());
      this.m_nextBtn.setEnabled(this.m_currentQuestion.isReadyToSubmit() && !(_loc2_ && this.m_currentQuestion.hasFeedback()));
      this.m_prevBtn.setEnabled(!_loc2_ && this.m_parent.isPrevQuestion());
   }
   function onPrevQuestion()
   {
      this.m_parent.onPrevQuestion();
      this.m_feedbackPanel.animate(false);
   }
   function onNextQuestion()
   {
      if(!this.m_currentQuestion.hasFeedback())
      {
         this.onSubmit();
      }
      this.m_parent.onNextQuestion();
      this.m_feedbackPanel.animate(false);
   }
   function onSubmit()
   {
      this.m_parent.onSubmit(this.m_currentQuestion.getUserData(),true);
      this.displayFeedback();
      this.m_curQuestionOrigUserData = this.m_currentQuestion.getUserData();
      this.updatePrevNextSubmit();
   }
   function userHasChangedAnswer()
   {
      return !com.techsmith.utils.Util.doObjectsMatch(this.m_curQuestionOrigUserData,this.m_currentQuestion.getUserData());
   }
   function displayFeedback()
   {
      if(!this.m_currentQuestion.hasFeedback())
      {
         return undefined;
      }
      if(this.m_currentQuestion.isCorrect())
      {
         this.m_currentQuestion.enable(false);
      }
      var _loc2_ = this.m_currentQuestion.getFeedback();
      this.m_feedbackPanel.setFeedback(_loc2_.strFeedback,_loc2_.strDetailedFeedback);
      this.m_feedbackPanel.move(this.m_contentX,this.m_contentY + (this.m_contentH - this.m_feedbackPanel.getHeight()));
      this.m_feedbackPanel.animate(true);
   }
   function feedbackCloseHandler(e)
   {
      this.m_feedbackPanel.animate(false);
   }
   function dispose()
   {
      this.m_prevBtn.removeEventListener("click",this);
      this.m_submitBtn.removeEventListener("click",this);
      this.m_nextBtn.removeEventListener("click",this);
      this.m_feedbackPanel.removeAllListeners();
   }
   function onUnload()
   {
      this.dispose();
   }
   function onEnter()
   {
      if(this.m_submitBtn.enabled)
      {
         this.onSubmit();
      }
      else if(this.m_nextBtn.enabled)
      {
         this.onNextQuestion();
      }
   }
}
