class com.techsmith.camtasia.flash.player.view.loader.MediaWindow extends com.techsmith.camtasia.flash.player.view.BaseView
{
   var onEnterFrame;
   static var STOPPED = 0;
   static var PAUSED = 1;
   static var PLAYING = 2;
   var m_fPlaystate = 0;
   var m_bFlvStopped = false;
   var m_fMaxDuration = 0;
   var m_fKeyFrameRateInSeconds = 0;
   var m_bIsFLV = null;
   var m_bIsMain = false;
   var m_bIsSeekingFLV = false;
   var m_fLastSeekTime = -1;
   var m_background = null;
   var m_content = null;
   var m_loader = null;
   var m_bPreloadComplete = false;
   var m_fPipSeekTime = 0;
   var m_fPipOldSeekTime = -1;
   var m_fUpdatePipId = -1;
   var m_fSeekNotifyId = -1;
   var m_fWidth = null;
   var m_fHeight = null;
   var m_netCon = null;
   var m_netStream = null;
   var m_vidContainer = null;
   var m_vidObj = null;
   var m_fFirstRun = true;
   var m_preloadChecker = null;
   var m_bAutoStart = false;
   function MediaWindow()
   {
      super();
      mx.events.EventDispatcher.initialize(this);
      this.m_background = this.createEmptyMovieClip("background",1);
      this.m_loader = new MovieClipLoader();
      this.m_loader.addListener(this);
   }
   function dispatchEvent()
   {
   }
   function addEventListener()
   {
   }
   function removeEventListener()
   {
   }
   function init(w, h, c, autoPlay, showLoading)
   {
      this.m_bAutoStart = autoPlay;
      if(autoPlay && !showLoading)
      {
         this.m_bPreloadComplete = true;
      }
      this.setBackgroundColor(c,w,h);
      this.setDimensions(w,h);
   }
   function move(x, y)
   {
      this._x = x;
      this._y = y;
   }
   function setDimensions(w, h)
   {
      this.m_fWidth = w;
      this.m_fHeight = h;
   }
   function setSize(w, h)
   {
      this._xscale = w;
      this._yscale = h;
   }
   function setBackgroundColor(c, w, h)
   {
      com.techsmith.utils.shapes.Rectangle.draw(this.m_background,c,w,h,100);
   }
   function loadFile(file, main, duration, keyFRInSec, firstRun)
   {
      this.m_fMaxDuration = duration;
      this.m_bIsMain = main;
      this.m_fFirstRun = firstRun;
      var _loc4_ = file.substr(file.lastIndexOf(".") + 1);
      switch(_loc4_)
      {
         case "swf":
            this.m_bIsFLV = false;
            this.setupSWF();
            this.m_preloadChecker = this.createEmptyMovieClip("m_preloadChecker",7077);
            this.m_loader.loadClip(file,this.m_content);
            this.m_preloadChecker.onEnterFrame = com.techsmith.utils.Delegate.create(this,this.checkPreloader);
            this.m_fPlaystate = com.techsmith.camtasia.flash.player.view.loader.MediaWindow.STOPPED;
            break;
         case "flv":
            this.m_bIsFLV = true;
            this.m_fKeyFrameRateInSeconds = keyFRInSec;
            this.setupVideo();
            this.m_netStream.play(file);
            this.seekFLV(0);
            this.m_fPlaystate = com.techsmith.camtasia.flash.player.view.loader.MediaWindow.STOPPED;
            if(this.m_bIsMain)
            {
               this.dispatchEvent({target:this,type:"firstFrameLoaded"});
               this.onEnterFrame = this.flvBytesLoading;
            }
            break;
         case "jpg":
            this.m_bIsFLV = false;
            this.setupSWF();
            this.m_loader.loadClip(file,this.m_content);
            this.m_fPlaystate = com.techsmith.camtasia.flash.player.view.loader.MediaWindow.STOPPED;
      }
   }
   function setupSWF()
   {
      this.m_content = this.createEmptyMovieClip("content",2);
   }
   function setupVideo()
   {
      this.m_content = this.attachMovie("vidContainer","content",2);
      this.m_vidObj = this.m_content.vidObj;
      this.m_vidContainer._width = this.m_fWidth;
      this.m_vidContainer._height = this.m_fHeight;
      this.m_vidObj._width = this.m_fWidth;
      this.m_vidObj._height = this.m_fHeight;
      this.m_netCon = new NetConnection();
      this.m_netCon.connect(null);
      this.m_netStream = new NetStream(this.m_netCon);
      this.m_vidObj.attachVideo(this.m_netStream);
      this.m_netStream.onStatus = com.techsmith.utils.Delegate.create(this,this.statusNotify);
   }
   function flvBytesLoading()
   {
      var _loc3_ = this.m_netStream.bytesLoaded;
      var _loc2_ = this.m_netStream.bytesTotal;
      if(_loc3_ <= _loc2_)
      {
         this.dispatchEvent({target:this,type:"mediaLoading",bytesLoaded:_loc3_,bytesTotal:_loc2_});
      }
      if(_loc3_ / _loc2_ * 100 == 100)
      {
         delete this.onEnterFrame;
      }
   }
   function checkPreloader()
   {
      if(this.m_content._currentframe >= 1)
      {
         this.dispatchEvent({target:this,type:"firstFrameLoaded"});
         if(this.m_fPlaystate == com.techsmith.camtasia.flash.player.view.loader.MediaWindow.STOPPED)
         {
            this.m_content.gotoAndStop(1);
         }
         if(this.m_bPreloadComplete)
         {
            delete this.m_preloadChecker.onEnterFrame;
         }
      }
   }
   function statusNotify(info)
   {
      for(var _loc3_ in info)
      {
         if(info[_loc3_] == "NetStream.Play.Stop")
         {
            this.m_bFlvStopped = true;
            this.m_bIsSeekingFLV = false;
            trace("*************** Got statusNotify saying FLV PLAYBACK STOPPED!*************");
         }
      }
      trace("m_bAutoStart: " + this.m_bAutoStart);
      if(info.code == "NetStream.Play.Start")
      {
         this.m_netStream.seek(0);
         if(this.m_fFirstRun && this.m_bAutoStart && this.m_bPreloadComplete)
         {
            this.m_netStream.pause(false);
         }
         else if(this.m_fFirstRun)
         {
            this.m_netStream.pause(true);
         }
      }
   }
   function setSeekingFalse(snapshot)
   {
      if(this.m_netStream.time != snapshot || this.m_fLastSeekTime != -1 && getTimer() - this.m_fLastSeekTime > 100)
      {
         clearInterval(this.m_fSeekNotifyId);
         this.m_fSeekNotifyId = -1;
         this.m_bIsSeekingFLV = false;
         if(this.m_bIsFLV && this.m_netStream.time < this.m_fMaxDuration && this.m_bFlvStopped == true && this.m_fPlaystate == com.techsmith.camtasia.flash.player.view.loader.MediaWindow.PLAYING)
         {
            this.m_netStream.pause(false);
            this.m_bFlvStopped = false;
         }
         this.dispatchEvent({target:this,type:"updateCurFrameInfo"});
      }
   }
   function seekFLV(seekTime)
   {
      if(this.m_fSeekNotifyId != -1)
      {
         clearInterval(this.m_fSeekNotifyId);
         this.m_fSeekNotifyId = -1;
      }
      if(seekTime != this.m_netStream.time)
      {
         if(this.m_fPlaystate != com.techsmith.camtasia.flash.player.view.loader.MediaWindow.PLAYING && (seekTime < this.m_netStream.time && this.m_netStream.time - seekTime < this.m_fKeyFrameRateInSeconds || seekTime == this.m_fMaxDuration))
         {
            this.m_fLastSeekTime = getTimer();
         }
         else
         {
            this.m_fLastSeekTime = -1;
         }
         this.m_fSeekNotifyId = setInterval(this,"setSeekingFalse",1,this.m_netStream.time);
         this.m_netStream.seek(seekTime);
         if(seekTime < this.m_fMaxDuration)
         {
            this.m_bIsSeekingFLV = true;
         }
      }
   }
   function getIsSeekingFLV()
   {
      return this.m_bIsSeekingFLV;
   }
   function getTotalBytes()
   {
      if(this.m_bIsFLV)
      {
         return this.m_netStream.bytesTotal;
      }
      return this.m_content.getBytesTotal();
   }
   function getCurrentPosition()
   {
      if(this.m_bIsFLV)
      {
         return this.m_netStream.time;
      }
      return this.m_content._currentframe;
   }
   function setPreloadComplete(preloadComplete)
   {
      this.m_bPreloadComplete = preloadComplete;
   }
   function getPreloadComplete()
   {
      return this.m_bPreloadComplete;
   }
   function getHeight()
   {
      return this.m_fHeight;
   }
   function getWidth()
   {
      return this.m_fWidth;
   }
   function getVideo()
   {
      return this.m_vidObj;
   }
   function getContent()
   {
      return this.m_content;
   }
   function getNetStream()
   {
      return this.m_netStream;
   }
   function getPlaystate()
   {
      return this.m_fPlaystate;
   }
   function getPosition()
   {
      var _loc2_ = {};
      _loc2_.x = this._x;
      _loc2_.y = this._y;
      return _loc2_;
   }
   function onLoadProgress(target, loadedBytes, totalBytes)
   {
      if(this.m_bIsMain)
      {
         this.dispatchEvent({target:this,type:"mediaLoading",bytesLoaded:loadedBytes,bytesTotal:totalBytes});
      }
   }
   function onLoadInit(target)
   {
      if(this.m_fPlaystate != com.techsmith.camtasia.flash.player.view.loader.MediaWindow.PLAYING)
      {
         this.m_content.gotoAndStop(1);
      }
   }
   function onLoadComplete(target)
   {
   }
   function moviePositionChange(e)
   {
      if(e.seekMainVidOnly == true && this.m_bIsMain == false)
      {
         return undefined;
      }
      if(e.seekMainOnly == false || this.m_bIsMain == true)
      {
         if(this.m_bIsFLV)
         {
            var _loc4_ = Math.min(this.m_fMaxDuration,e.seekTime);
            this.seekFLV(_loc4_);
            var _loc6_ = Number(e.seekTime);
            var _loc5_ = Number(this.m_fMaxDuration);
            if(this.m_fPlaystate == com.techsmith.camtasia.flash.player.view.loader.MediaWindow.PLAYING && _loc6_ < _loc5_)
            {
               this.m_fPlaystate = com.techsmith.camtasia.flash.player.view.loader.MediaWindow.PLAYING;
               this.m_netStream.pause(false);
            }
            else if(this.m_bIsMain)
            {
               this.m_fPlaystate = com.techsmith.camtasia.flash.player.view.loader.MediaWindow.PAUSED;
               this.m_netStream.pause(true);
            }
         }
         else
         {
            var _loc3_ = Math.max(1,e.seekFrame);
            if(_loc3_ >= this.m_fMaxDuration)
            {
               this.m_content.gotoAndStop(this.m_fMaxDuration);
            }
            else if(this.m_fPlaystate == com.techsmith.camtasia.flash.player.view.loader.MediaWindow.PLAYING)
            {
               this.m_content.gotoAndPlay(_loc3_);
            }
            else
            {
               this.m_content.gotoAndStop(_loc3_);
            }
         }
      }
      if(this.m_fPlaystate != com.techsmith.camtasia.flash.player.view.loader.MediaWindow.PLAYING && (e.seekMainOnly == false || this.m_bIsMain == true))
      {
         this.dispatchEvent({target:this,type:"updateCurFrameInfo"});
      }
      if(this.m_bIsFLV && this.m_fPlaystate == com.techsmith.camtasia.flash.player.view.loader.MediaWindow.PLAYING && this.m_bFlvStopped == true)
      {
         trace("*** FORCING IT TO PLAY AFTER A SEEK *** -- m_bMain: " + this.m_bIsMain);
         this.m_netStream.pause(false);
         this.m_bFlvStopped = false;
      }
   }
   function updatePipTime(obj)
   {
      if(obj.getIsSeekingFLV() == false)
      {
         clearInterval(obj.m_fUpdatePipId);
         var _loc2_ = Number(obj.m_netStream.time);
         obj.dispatchEvent({target:obj,type:"pipSeekedEvent",seekTime:_loc2_});
         obj.m_fUpdatePipId = -1;
         obj.m_fPipOldSeekTime = -1;
      }
   }
   function pipPositionChange(e)
   {
      this.m_fPipSeekTime = e.seekTime;
      if(this.m_fPipSeekTime != this.m_fPipOldSeekTime)
      {
         if(this.m_fUpdatePipId != -1)
         {
            this.dispatchEvent({target:this,type:"pipSeekedEvent",seekTime:this.m_netStream.time});
            clearInterval(this.m_fUpdatePipId);
         }
         this.seekFLV(Math.min(this.m_fMaxDuration,e.seekTime));
         this.m_fPipOldSeekTime = this.m_fPipSeekTime;
         this.m_fUpdatePipId = setInterval(this.updatePipTime,50,this);
      }
   }
   function playMovie()
   {
      if(this.m_fPlaystate != com.techsmith.camtasia.flash.player.view.loader.MediaWindow.PLAYING)
      {
         if(this.m_bIsFLV)
         {
            trace("--- Playing FLV!!! ---");
            this.m_netStream.pause(false);
         }
         else
         {
            trace("--- Playing SWF!!! ---");
            if(this.m_content._currentframe < this.m_fMaxDuration)
            {
               this.m_content.gotoAndPlay(this.m_content._currentframe);
            }
            else
            {
               this.m_content.gotoAndStop(this.m_fMaxDuration);
            }
         }
         this.m_fPlaystate = com.techsmith.camtasia.flash.player.view.loader.MediaWindow.PLAYING;
      }
      else
      {
         trace("### Tried to play movie, but it\'s already playing!! -- m_bIsFLV: " + this.m_bIsFLV);
      }
   }
   function stopMovie()
   {
      this.stopMovieAndGotoFrame(null);
   }
   function stopMovieAndGotoFrame(frame)
   {
      if(this.m_fPlaystate == com.techsmith.camtasia.flash.player.view.loader.MediaWindow.STOPPED)
      {
         trace("### Stopping movie, but it\'s already set to stopped!! -- m_bIsFLV: " + this.m_bIsFLV);
      }
      if(this.m_bIsFLV)
      {
         trace("--- Stopping FLV!!! ---");
         this.m_netStream.pause(true);
         this.seekFLV(0);
      }
      else
      {
         trace("--- Stopping SWF!!! ---");
         if(frame == undefined || frame == null)
         {
            this.m_content.gotoAndStop(1);
         }
         else
         {
            this.m_content.gotoAndStop(frame);
         }
      }
      this.m_fPlaystate = com.techsmith.camtasia.flash.player.view.loader.MediaWindow.STOPPED;
      this.dispatchEvent({target:this,type:"updateCurFrameInfo"});
   }
   function pauseMovie()
   {
      if(this.m_fPlaystate != com.techsmith.camtasia.flash.player.view.loader.MediaWindow.PAUSED)
      {
         if(this.m_bIsFLV)
         {
            trace("--- Pausing FLV!!! ---");
            this.m_netStream.pause(true);
         }
         else
         {
            trace("--- Pausing SWF!!! ---");
            this.m_content.stop();
         }
         this.m_fPlaystate = com.techsmith.camtasia.flash.player.view.loader.MediaWindow.PAUSED;
      }
      else
      {
         trace("### Tried to pause movie, but it\'s already playing!! -- m_bIsFLV: " + this.m_bIsFLV);
      }
      this.dispatchEvent({target:this,type:"updateCurFrameInfo"});
   }
}
